Index: /main/trunk/greenstone2/bin/script/gti.pl
===================================================================
--- /main/trunk/greenstone2/bin/script/gti.pl	(revision 24626)
+++ /main/trunk/greenstone2/bin/script/gti.pl	(revision 24627)
@@ -479,32 +475,32 @@
     my %target_file_key_to_text_mapping = ();
     my %target_file_key_to_gti_comment_mapping = ();
-
+	
     my (@source_file_lines, @target_file_lines) = ();
     my ($source_file, $target_file, $translation_file_type);
-
+	
     
     if ($translation_file_key ne "gs3interface") {
-	# Get (and check) the translation configuration
-	($source_file, $target_file, $translation_file_type)
+		# Get (and check) the translation configuration
+		($source_file, $target_file, $translation_file_type)
 	    = &get_translation_configuration($target_language_code, $translation_file_key);
-
-	# Parse the source language and target language files
-	@source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
-	my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
-	%source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
-	%source_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);	
-
-	@target_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $target_file));
-	my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-	%target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-	%target_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);	
+		
+		# Parse the source language and target language files
+		@source_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $source_file));
+		my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
+		%source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
+		%source_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);	
+		
+		@target_file_lines = &read_file_lines(&util::filename_cat($gsdl_root_directory, $target_file));
+		my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
+		%target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+		%target_file_key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);	
     } 
     else {
-	&build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, 
-				 \%source_file_key_to_gti_comment_mapping, \%target_file_key_to_gti_comment_mapping);
+		&build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, 
+		\%source_file_key_to_gti_comment_mapping, \%target_file_key_to_gti_comment_mapping);
     }
     &log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
     &log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
-
+	
     # Submission date
     my $day = (localtime)[3];
@@ -512,96 +508,96 @@
     my $year = (localtime)[5] + 1900;
     my $submission_date = "$day-$month-$year";
-
+	
     open(SUBMISSION, "-");
     my @submission_lines = <SUBMISSION>;
     close(SUBMISSION);
-
+	
     # Remove any nasty carriage returns
     # &log_message("Submission:");
     foreach my $submission_line (@submission_lines) {
-	$submission_line =~ s/\r$//;
-	#&log_message("  $submission_line");
-    }
-
+		$submission_line =~ s/\r$//;
+		#&log_message("  $submission_line");
+    }
+	
     my %source_file_key_to_submission_mapping = ();
     my %target_file_key_to_submission_mapping = ();
     for (my $i = 0; $i < scalar(@submission_lines); $i++) {
-	# Read source file part of submission
-	if ($submission_lines[$i] =~ /^\<SourceFileText key=\"(.+)\"\>/) {
-	    my $chunk_key = $1;
-
-	    # Read the source file text
-	    my $source_file_chunk_text = "";
-	    $i++;
-	    while ($i < scalar(@submission_lines) && $submission_lines[$i] !~ /^\<\/SourceFileText\>/) {
-		$source_file_chunk_text .= $submission_lines[$i];
- 		$i++;
-	    }
-	    $source_file_chunk_text =~ s/\n$//;  # Strip the extra newline character added
-	    $source_file_chunk_text = &unmake_text_xml_safe($source_file_chunk_text);
-
-	    #&log_message("Source file key: $chunk_key");
-	    #&log_message("Source file text: $source_file_chunk_text");
-	    $source_file_key_to_submission_mapping{$chunk_key} = $source_file_chunk_text;
-	}
-
-	# Read target file part of submission
-	if ($submission_lines[$i] =~ /^\<TargetFileText key=\"(.+)\"\>/) {
-	    my $chunk_key = $1;
-
-	    # Read the target file text
-	    my $target_file_chunk_text = "";
-	    $i++;
-	    while ($i < scalar(@submission_lines) && $submission_lines[$i] !~ /^\<\/TargetFileText\>/) {
-		$target_file_chunk_text .= $submission_lines[$i];
- 		$i++;
-	    }
-	    $target_file_chunk_text =~ s/\n$//;  # Strip the extra newline character added
-	    $target_file_chunk_text = &unmake_text_xml_safe($target_file_chunk_text);
-
-	    #&log_message("Target file key: $chunk_key");
-	    #&log_message("Target file text: $target_file_chunk_text");
-	    $target_file_key_to_submission_mapping{$chunk_key} = $target_file_chunk_text;
-	}
-    }
-
+		# Read source file part of submission
+		if ($submission_lines[$i] =~ /^\<SourceFileText key=\"(.+)\"\>/) {
+			my $chunk_key = $1;
+			
+			# Read the source file text
+			my $source_file_chunk_text = "";
+			$i++;
+			while ($i < scalar(@submission_lines) && $submission_lines[$i] !~ /^\<\/SourceFileText\>/) {
+				$source_file_chunk_text .= $submission_lines[$i];
+				$i++;
+			}
+			$source_file_chunk_text =~ s/\n$//;  # Strip the extra newline character added
+			$source_file_chunk_text = &unmake_text_xml_safe($source_file_chunk_text);
+			
+			#&log_message("Source file key: $chunk_key");
+			#&log_message("Source file text: $source_file_chunk_text");
+			$source_file_key_to_submission_mapping{$chunk_key} = $source_file_chunk_text;
+		}
+		
+		# Read target file part of submission
+		if ($submission_lines[$i] =~ /^\<TargetFileText key=\"(.+)\"\>/) {
+			my $chunk_key = $1;
+			
+			# Read the target file text
+			my $target_file_chunk_text = "";
+			$i++;
+			while ($i < scalar(@submission_lines) && $submission_lines[$i] !~ /^\<\/TargetFileText\>/) {
+				$target_file_chunk_text .= $submission_lines[$i];
+				$i++;
+			}
+			$target_file_chunk_text =~ s/\n$//;  # Strip the extra newline character added
+			$target_file_chunk_text = &unmake_text_xml_safe($target_file_chunk_text);
+			
+			#&log_message("Target file key: $chunk_key");
+			#&log_message("Target file text: $target_file_chunk_text");
+			$target_file_key_to_submission_mapping{$chunk_key} = $target_file_chunk_text;
+		}
+    }
+	
     # -----------------------------------------
     #   Validate the translation submissions
     # -----------------------------------------
-
+	
     # Check that the translations are valid
     foreach my $chunk_key (keys(%source_file_key_to_submission_mapping)) {
-	# Make sure the submitted chunk still exists in the source file
-	if (!defined($source_file_key_to_text_mapping{$chunk_key})) {
-	    &log_message("Warning: Source chunk $chunk_key no longer exists (ignoring submission).");
-	    delete $source_file_key_to_submission_mapping{$chunk_key};
-	    delete $target_file_key_to_submission_mapping{$chunk_key};
-	    next;
-	}
-
-	# Make sure the submitted source chunk matches the source file chunk
-	if ($source_file_key_to_submission_mapping{$chunk_key} ne &unmake_text_xml_safe($source_file_key_to_text_mapping{$chunk_key})) {
-	    &log_message("Warning: Source chunk $chunk_key has changed (ignoring submission).");
-	    &log_message("Submission source: $source_file_key_to_submission_mapping{$chunk_key}");
-	    &log_message("      Source text: $source_file_key_to_text_mapping{$chunk_key}");
-	    delete $source_file_key_to_submission_mapping{$chunk_key};
-	    delete $target_file_key_to_submission_mapping{$chunk_key};
-	    next;
-	}
-    }
-
+		# Make sure the submitted chunk still exists in the source file
+		if (!defined($source_file_key_to_text_mapping{$chunk_key})) {
+			&log_message("Warning: Source chunk $chunk_key no longer exists (ignoring submission).");
+			delete $source_file_key_to_submission_mapping{$chunk_key};
+			delete $target_file_key_to_submission_mapping{$chunk_key};
+			next;
+		}
+		
+		# Make sure the submitted source chunk matches the source file chunk
+		if ($source_file_key_to_submission_mapping{$chunk_key} ne &unmake_text_xml_safe($source_file_key_to_text_mapping{$chunk_key})) {
+			&log_message("Warning: Source chunk $chunk_key has changed (ignoring submission).");
+			&log_message("Submission source: $source_file_key_to_submission_mapping{$chunk_key}");
+			&log_message("      Source text: $source_file_key_to_text_mapping{$chunk_key}");
+			delete $source_file_key_to_submission_mapping{$chunk_key};
+			delete $target_file_key_to_submission_mapping{$chunk_key};
+			next;
+		}
+    }
+	
     # Apply the submitted translations
     foreach my $chunk_key (keys(%target_file_key_to_submission_mapping)) {
-	# Only apply the submission if it is a change, unless -force_submission has been specified
-	if ($force_submission_flag || !defined($target_file_key_to_text_mapping{$chunk_key}) || $target_file_key_to_submission_mapping{$chunk_key} ne $target_file_key_to_text_mapping{$chunk_key}) {
-	    $target_file_key_to_text_mapping{$chunk_key} = $target_file_key_to_submission_mapping{$chunk_key};
-	    $target_file_key_to_gti_comment_mapping{$chunk_key} = "Updated $submission_date by $submitter_username";
-	}
+		# Only apply the submission if it is a change, unless -force_submission has been specified
+		if ($force_submission_flag || !defined($target_file_key_to_text_mapping{$chunk_key}) || $target_file_key_to_submission_mapping{$chunk_key} ne $target_file_key_to_text_mapping{$chunk_key}) {
+			$target_file_key_to_text_mapping{$chunk_key} = $target_file_key_to_submission_mapping{$chunk_key};
+			$target_file_key_to_gti_comment_mapping{$chunk_key} = "Updated $submission_date by $submitter_username";
+		}
     }
     
     if ($translation_file_key ne "gs3interface") {
-	eval "&write_translated_${translation_file_type}(\$source_file, \\\@source_file_lines, \\\%source_file_key_to_text_mapping, \$target_file, \\\@target_file_lines, \\\%target_file_key_to_text_mapping, \\\%target_file_key_to_gti_comment_mapping, \$target_language_code)";
+		eval "&write_translated_${translation_file_type}(\$source_file, \\\@source_file_lines, \\\%source_file_key_to_text_mapping, \$target_file, \\\@target_file_lines, \\\%target_file_key_to_text_mapping, \\\%target_file_key_to_gti_comment_mapping, \$target_language_code)";
     } else {
-	eval "&write_translated_gs3interface(\\\%source_file_key_to_text_mapping, \\\%target_file_key_to_text_mapping, \\\%target_file_key_to_gti_comment_mapping, \$target_language_code)";
+		eval "&write_translated_gs3interface(\\\%source_file_key_to_text_mapping, \\\%target_file_key_to_text_mapping, \\\%target_file_key_to_gti_comment_mapping, \$target_language_code)";
     }
 }
@@ -614,10 +610,10 @@
     
     &log_message("Creating GLI Help zip file for $target_language_code");
-
+	
     my ($source_file, $target_file, $translation_file_type) = &get_translation_data_for($target_language_code, $translation_file_key);    
     
     my $classpath = &util::filename_cat($gsdl_root_directory, "gti-lib");
     if ( ! -e $classpath) {
-	&throw_fatal_error("$classpath doesn't exist! Need the files in this directory (ApplyXLST and its related files) to create the zip file for GLI Help");
+		&throw_fatal_error("$classpath doesn't exist! Need the files in this directory (ApplyXLST and its related files) to create the zip file for GLI Help");
     }    
     
@@ -627,7 +623,7 @@
     my $gen_many_html_xsl_filepath = &util::filename_cat($gli_help_directory, "gen-many-html.xsl");
     if ( ! -e $gen_many_html_xsl_filepath) {
-	&throw_fatal_error("$gen_many_html_xsl_filepath doesn't exist! Need this file to create the zip file for GLI Help");
-    }
-
+		&throw_fatal_error("$gen_many_html_xsl_filepath doesn't exist! Need this file to create the zip file for GLI Help");
+    }
+	
     my $gen_index_xml_xsl_filepath = &util::filename_cat($gli_help_directory, "gen-index-xml.xsl");   
     my $split_script_filepath = &util::filename_cat($gli_help_directory, "splithelpdocument.pl");   
@@ -635,30 +631,22 @@
     my $target_file_directory = &util::filename_cat($gli_help_directory, $target_language_code);
     $target_file_directory = $target_file_directory."/";
-
+	
     my $target_filepath = &util::filename_cat($gsdl_root_directory, $target_file);
-    my $perl_exec = &util::get_perl_exec();
-    my $java_exec = "java";
-    if(defined($ENV{'JAVA_HOME'}) && $ENV{'JAVA_HOME'} ne ""){
-	$java_exec = &util::filename_cat($ENV{'JAVA_HOME'}, "bin", "java");
-    }
-
+	
+	my $perl_exec = &util::get_perl_exec();
+	my $java_exec = "java";
+	if(defined($ENV{'JAVA_HOME'}) && $ENV{'JAVA_HOME'} ne ""){
+		$java_exec = &util::filename_cat($ENV{'JAVA_HOME'}, "bin", "java");
+	}
+	
     my $cmd = "$java_exec -cp $classpath:$classpath/xalan.jar ApplyXSLT $target_language_code $gen_many_html_xsl_filepath $target_filepath | \"$perl_exec\" -S $split_script_filepath $target_file_directory";
     my $response = `$cmd`;
-    &log_message($cmd);
-    &log_message($response);    
-    &log_message("Created HTML operational files");
-    
+        
     $cmd = "$java_exec -cp $classpath:$classpath/xalan.jar ApplyXSLT $target_language_code $gen_index_xml_xsl_filepath $target_filepath > " . $target_file_directory . "help_index.xml"; # 2>/dev/null";
     $response = `$cmd`;
-    &log_message($cmd);
-    &log_message($response);    
-    &log_message("Created xml index file");
-
+	
     my $zip_file_path = "/greenstone/custom/gti/" . $target_language_code . "_GLIHelp.zip";
     $cmd = "zip -rj $zip_file_path $target_file_directory -i \*.htm \*.xml";
     $response = `$cmd`;
-    &log_message($cmd);
-    &log_message($response);    
-    &log_message("Created the zip file");
 }
 
@@ -670,25 +658,25 @@
     # Get the key of the file to translate
     my $translation_file_key = shift(@_);
-
+	
     # Read the translation data from the gti.cfg file
     my ($source_file, $target_file, $translation_file_type) =
 	&get_translation_data_for($target_language_code, $translation_file_key);
-
+	
     # Check that the file to translate is defined in the gti.cfg file
     if (!$source_file || !$target_file || !$translation_file_type) {
-	&throw_fatal_error("Missing or incomplete specification for translation file \"$translation_file_key\" in gti.pl.");
-    }
-
+		&throw_fatal_error("Missing or incomplete specification for translation file \"$translation_file_key\" in gti.pl.");
+    }
+	
     # Check that the source file exists
     my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
     if (!-e $source_file_path) {
-	&throw_fatal_error("Source file $source_file_path does not exist.");
-    }
-
+		&throw_fatal_error("Source file $source_file_path does not exist.");
+    }
+	
     # Check that the source file is up to date
     # The "2>/dev/null" is very important! If it is missing this will never return when run from the receptionist
     # unless ($translation_file_is_not_in_cvs) {
 	#my $source_file_cvs_status = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root update $source_file 2>/dev/null`;
-        my $source_file_cvs_status = `cd $gsdl_root_directory; svn status $source_file 2>/dev/null`;
+	my $source_file_cvs_status = `cd $gsdl_root_directory; svn status $source_file 2>/dev/null`;
 	if ($source_file_cvs_status =~ /^C /) {
 	    &throw_fatal_error("Source file $source_file_path conflicts with the repository.");
@@ -698,5 +686,5 @@
 	}
     # }
-
+	
     return ($source_file, $target_file, $translation_file_type);
 }
@@ -706,38 +694,38 @@
 {
     my ($target_language_code, $translation_file_key) = @_;
-
+	
     foreach my $translation_file (@$gti_translation_files) {
-	# If this isn't the correct translation file, move onto the next one
-	next if ($translation_file_key ne $translation_file->{'key'});
-
-	# Resolve the target language file
-	my $target_language_file = $translation_file->{'target_file'};
-	if ($target_language_file =~ /(\{.+\;.+\})/) {
-	    my $unresolved_target_language_file_part = $1;
-
-	    # Check for a special case for the target language code
-	    if ($unresolved_target_language_file_part =~ /(\{|\;)$target_language_code:([^\;]+)(\;|\})/) {
-		my $resolved_target_language_file_part = $2;
-		$target_language_file =~ s/$unresolved_target_language_file_part/$resolved_target_language_file_part/;
-	    }
-	    # Otherwise use the last part as the default value
-	    else {
-		my ($default_target_language_file_part) = $unresolved_target_language_file_part =~ /([^\;]+)\}/;
-		$target_language_file =~ s/$unresolved_target_language_file_part/\{$default_target_language_file_part\}/;		    
+		# If this isn't the correct translation file, move onto the next one
+		next if ($translation_file_key ne $translation_file->{'key'});
+		
+		# Resolve the target language file
+		my $target_language_file = $translation_file->{'target_file'};
+		if ($target_language_file =~ /(\{.+\;.+\})/) {
+			my $unresolved_target_language_file_part = $1;
+			
+			# Check for a special case for the target language code
+			if ($unresolved_target_language_file_part =~ /(\{|\;)$target_language_code:([^\;]+)(\;|\})/) {
+				my $resolved_target_language_file_part = $2;
+				$target_language_file =~ s/$unresolved_target_language_file_part/$resolved_target_language_file_part/;
+			}
+			# Otherwise use the last part as the default value
+			else {
+				my ($default_target_language_file_part) = $unresolved_target_language_file_part =~ /([^\;]+)\}/;
+			$target_language_file =~ s/$unresolved_target_language_file_part/\{$default_target_language_file_part\}/;		    
 	    }
 	}
-
+	
 	# Resolve instances of {iso_639_1_target_language_name}
 	my $iso_639_1_target_language_name = $iso639::fromiso639{$target_language_code};
 	$iso_639_1_target_language_name =~ tr/A-Z/a-z/ if $iso_639_1_target_language_name;
 	$target_language_file =~ s/\{iso_639_1_target_language_name\}/$iso_639_1_target_language_name/g;
-
+	
 	# Resolve instances of {target_language_code}
 	$target_language_file =~ s/\{target_language_code\}/$target_language_code/g;
-
+	
 	return ($translation_file->{'source_file'}, $target_language_file, $translation_file->{'file_type'});
-    }
-
-    return ();
+}
+
+return ();
 }
 
@@ -746,12 +734,12 @@
 {
     my ($file_path) = @_;
-
+	
     if (!open(FILE_IN, "<$file_path")) {
-	&log_message("Note: Could not open file $file_path.");
-	return ();
+		&log_message("Note: Could not open file $file_path.");
+		return ();
     }
     my @file_lines = <FILE_IN>;
     close(FILE_IN);
-
+	
     return @file_lines;
 }
@@ -768,19 +756,19 @@
 {
     my ($file_lines, $key_to_line_mapping, $translation_file_type) = @_;
-
+	
     my %key_to_text_mapping = ();
     foreach my $chunk_key (keys(%$key_to_line_mapping)) {
-	my $chunk_starting_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[0];
-	my $chunk_finishing_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[1];
-
-	my $chunk_text = @$file_lines[$chunk_starting_line];
-	for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
-	    $chunk_text .= @$file_lines[$l];
-	}
-
-	# Map from chunk key to text
-	eval "\$key_to_text_mapping{\${chunk_key}} = &import_chunk_from_${translation_file_type}(\$chunk_text)";
-    }
-
+		my $chunk_starting_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[0];
+		my $chunk_finishing_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[1];
+		
+		my $chunk_text = @$file_lines[$chunk_starting_line];
+		for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
+			$chunk_text .= @$file_lines[$l];
+		}
+		
+		# Map from chunk key to text
+		eval "\$key_to_text_mapping{\${chunk_key}} = &import_chunk_from_${translation_file_type}(\$chunk_text)";
+    }
+	
     return %key_to_text_mapping;
 }
@@ -790,40 +778,33 @@
 {
     my ($file, $file_lines, $key_to_line_mapping, $translation_file_type) = @_;
-
+	
     # If the files aren't in CVS then we can't tell anything about what needs updating
     # return () if ($translation_file_is_not_in_cvs);
-
+	
     # Build a mapping from key to CVS date
     # Need to be careful with this mapping because the chunk keys won't necessarily all be valid
     my %key_to_cvs_date_mapping = &build_key_to_cvs_date_mapping($file, $translation_file_type);
-
+	
     # Build a mapping from key to comment date
     my %key_to_gti_comment_mapping = &build_key_to_gti_comment_mapping($file_lines, $key_to_line_mapping, $translation_file_type);
-
+	
     # Build a mapping from key to last update date (the latter of the CVS date and comment date)
     my %key_to_last_update_date_mapping = ();
     foreach my $chunk_key (keys(%$key_to_line_mapping)) {
-	# Use the CVS date as a starting point
-	my $chunk_cvs_date = $key_to_cvs_date_mapping{$chunk_key};
-	$key_to_last_update_date_mapping{$chunk_key} = $chunk_cvs_date;
-
-	# If a comment date exists and it is after the CVS date, use that instead
+		# Use the CVS date as a starting point
+		my $chunk_cvs_date = $key_to_cvs_date_mapping{$chunk_key};
+		$key_to_last_update_date_mapping{$chunk_key} = $chunk_cvs_date;
+		
+		# If a comment date exists and it is after the CVS date, use that instead
         # need to convert the comment date format to SVN format
-	my $chunk_gti_comment = $key_to_gti_comment_mapping{$chunk_key};
-	if (defined($chunk_gti_comment) && $chunk_gti_comment =~ /(\d?\d-\D\D\D-\d\d\d\d)/) {
-	    my $chunk_comment_date = $1;            
-	    # if the changes were made on 2009 Jan 27, ie. tidying up the GTI commands following each fragment, 
-	    # then should use the GTI comment date instead
-	    # if ((!defined($chunk_cvs_date) || &is_date_after($chunk_comment_date, $chunk_cvs_date))) {
-	    if ((!defined($chunk_cvs_date) || &is_date_after($chunk_comment_date, $chunk_cvs_date) 
-		 || (&is_date_after($chunk_cvs_date,$chunk_comment_date) && ($chunk_cvs_date eq "2009-01-27" || $chunk_cvs_date eq "2009-01-28")))) {
-		$key_to_last_update_date_mapping{$chunk_key} = $chunk_comment_date;
-		
-		# &log_message("cvs date: $chunk_cvs_date, comment date: $chunk_comment_date");
-		# die;
-	    }
-	}
-    }
-
+		my $chunk_gti_comment = $key_to_gti_comment_mapping{$chunk_key};
+		if (defined($chunk_gti_comment) && $chunk_gti_comment =~ /(\d?\d-\D\D\D-\d\d\d\d)/) {
+			my $chunk_comment_date = $1;           
+			if ((!defined($chunk_cvs_date) || &is_date_after($chunk_comment_date, $chunk_cvs_date))) {
+				$key_to_last_update_date_mapping{$chunk_key} = $chunk_comment_date;			
+			}
+		}
+    }
+	
     return %key_to_last_update_date_mapping;
 }
@@ -833,19 +814,15 @@
 {
     my ($filename, $translation_file_type) = @_;
-
-    # Use CVS to annotate each line of the file with the date it was last edited
+	
+    # Use SVN to annotate each line of the file with the date it was last edited
     # The "2>/dev/null" is very important! If it is missing this will never return when run from the receptionist
-    # my $cvs_annotated_file = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root annotate -F $filename 2>/dev/null`;    
-    # my $cvs_annotated_file = `cd $gsdl_root_directory; export PATH=.:/research/lh92/programs/subversion/bin; svn annotate -v --force $filename`;
-    my $cvs_annotated_file = `cd $gsdl_root_directory; svn annotate -v $filename`;
+    my $cvs_annotated_file = `cd $gsdl_root_directory; svn annotate -v --force $filename 2>/dev/null`;
     
     my @cvs_annotated_file_lines = split(/\n/, $cvs_annotated_file);
-
+	
     my @cvs_annotated_file_lines_date = ();
     foreach my $cvs_annotated_file_line (@cvs_annotated_file_lines) {
-	# Extract the date from the CVS annotation at the front
-        # cvs format : 07-Jun-02
-        # svn format : 2007-07-16
-	# $cvs_annotated_file_line =~ s/^\S+\s+\(\S+\s+(\S+)\):\s//;
+		# Extract the date from the SVN annotation at the front
+		# svn format : 2007-07-16
         $cvs_annotated_file_line =~ s/^\s+\S+\s+\S+\s(\S+)//; 
         
@@ -859,24 +836,24 @@
     # Build a key to line mapping for the CVS annotated file, for matching the chunk key to the CVS date
     my %key_to_line_mapping = &build_key_to_line_mapping(\@cvs_annotated_file_lines, $translation_file_type);
-        
+	
     my %key_to_cvs_date_mapping = ();
     foreach my $chunk_key (keys(%key_to_line_mapping)) {
- 	my $chunk_starting_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[0];
- 	my $chunk_finishing_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[1];
-                
- 	# Find the date this chunk was last edited, from the CVS annotation
- 	my $chunk_date = $cvs_annotated_file_lines_date[$chunk_starting_line];        
- 	for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
- 	    if (&is_date_after($cvs_annotated_file_lines_date[$l], $chunk_date)) {
- 		# This part of the chunk has been updated more recently
- 		$chunk_date = $cvs_annotated_file_lines_date[$l];
- 		
- 	    }
- 	}
-
- 	# Map from chunk key to CVS date
- 	$key_to_cvs_date_mapping{$chunk_key} = $chunk_date;
-    }
-
+		my $chunk_starting_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[0];
+		my $chunk_finishing_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[1];
+		
+		# Find the date this chunk was last edited, from the CVS annotation
+		my $chunk_date = $cvs_annotated_file_lines_date[$chunk_starting_line];        
+		for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
+			if (&is_date_after($cvs_annotated_file_lines_date[$l], $chunk_date)) {
+				# This part of the chunk has been updated more recently
+				$chunk_date = $cvs_annotated_file_lines_date[$l];
+				
+			}
+		}
+		
+		# Map from chunk key to CVS date
+		$key_to_cvs_date_mapping{$chunk_key} = $chunk_date;
+    }
+	
     return %key_to_cvs_date_mapping;
 }
@@ -886,21 +863,21 @@
 {
     my ($file_lines, $key_to_line_mapping, $translation_file_type) = @_;
-
+	
     my %key_to_gti_comment_mapping = ();
     foreach my $chunk_key (keys(%$key_to_line_mapping)) {
-	my $chunk_starting_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[0];
-	my $chunk_finishing_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[1];
-
-	my $chunk_text = @$file_lines[$chunk_starting_line];
-	for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
-	    $chunk_text .= @$file_lines[$l];
-	}
-
-	# Map from chunk key to GTI comment
-	my $chunk_gti_comment;
-	eval "\$chunk_gti_comment = &get_${translation_file_type}_chunk_gti_comment(\$chunk_text)";
-	$key_to_gti_comment_mapping{$chunk_key} = $chunk_gti_comment if (defined($chunk_gti_comment));
-    }
-
+		my $chunk_starting_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[0];
+		my $chunk_finishing_line = (split(/-/, $key_to_line_mapping->{$chunk_key}))[1];
+		
+		my $chunk_text = @$file_lines[$chunk_starting_line];
+		for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
+			$chunk_text .= @$file_lines[$l];
+		}
+		
+		# Map from chunk key to GTI comment
+		my $chunk_gti_comment;
+		eval "\$chunk_gti_comment = &get_${translation_file_type}_chunk_gti_comment(\$chunk_text)";
+		$key_to_gti_comment_mapping{$chunk_key} = $chunk_gti_comment if (defined($chunk_gti_comment));
+    }
+	
     return %key_to_gti_comment_mapping;
 }
@@ -911,14 +888,14 @@
     my $source_file_key_to_text_mapping = shift(@_);
     my $target_file_key_to_text_mapping = shift(@_);
-
+	
     # Chunks needing translation are those in the source file with no translation in the target file
     my @target_file_keys_requiring_translation = ();
     foreach my $chunk_key (keys(%$source_file_key_to_text_mapping)) {
-	if ($source_file_key_to_text_mapping->{$chunk_key} && !$target_file_key_to_text_mapping->{$chunk_key}) {
-	    # &log_message("Chunk with key $chunk_key needs translating.");
-	    push(@target_file_keys_requiring_translation, $chunk_key);
-	}
-    }
-
+		if ($source_file_key_to_text_mapping->{$chunk_key} && !$target_file_key_to_text_mapping->{$chunk_key}) {
+			# &log_message("Chunk with key $chunk_key needs translating.");
+			push(@target_file_keys_requiring_translation, $chunk_key);
+		}
+    }
+	
     return @target_file_keys_requiring_translation;
 }
@@ -929,19 +906,19 @@
     my $source_file_key_to_last_update_date_mapping = shift(@_);
     my $target_file_key_to_last_update_date_mapping = shift(@_);
-
+	
     # Chunks needing updating are those in the target file that have been more recently edited in the source file
     my @target_file_keys_requiring_updating = ();
     foreach my $chunk_key (keys(%$source_file_key_to_last_update_date_mapping)) {
-	my $source_chunk_last_update_date = $source_file_key_to_last_update_date_mapping->{$chunk_key};
- 	my $target_chunk_last_update_date = $target_file_key_to_last_update_date_mapping->{$chunk_key};
+		my $source_chunk_last_update_date = $source_file_key_to_last_update_date_mapping->{$chunk_key};
+		my $target_chunk_last_update_date = $target_file_key_to_last_update_date_mapping->{$chunk_key};
         
         # print "key: $chunk_key\nsource date : $source_chunk_last_update_date\ntarget date : $target_chunk_last_update_date\nafter? ". &is_date_after($source_chunk_last_update_date, $target_chunk_last_update_date) . "\n\n";        
-                	
+		
         if (defined($target_chunk_last_update_date) && &is_date_after($source_chunk_last_update_date, $target_chunk_last_update_date)) {
-	    # &log_message("Chunk with key $chunk_key needs updating.");
-	    push(@target_file_keys_requiring_updating, $chunk_key);
- 	}
-    }
-
+			# &log_message("Chunk with key $chunk_key needs updating.");
+			push(@target_file_keys_requiring_updating, $chunk_key);
+		}
+    }
+	
     return @target_file_keys_requiring_updating;
 }
@@ -984,13 +961,13 @@
     my ($date1, $date2) = @_;
     my %months = ("Jan", 1, "Feb", 2, "Mar", 3, "Apr",  4, "May",  5, "Jun",  6,
-		  "Jul", 7, "Aug", 8, "Sep", 9, "Oct", 10, "Nov", 11, "Dec", 12);
-
+	"Jul", 7, "Aug", 8, "Sep", 9, "Oct", 10, "Nov", 11, "Dec", 12);
+	
 	if(!defined $date1) {
 		return 1;
 	}
-
+	
     my @date1parts = split(/-/, $date1);
     my @date2parts = split(/-/, $date2);
-
+	
     # Compare year - nasty because we have rolled over into a new century
     my $year1 = $date1parts[2];
